package com.mortals.xhx.module.bussinesscard.web;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.base.system.user.model.UserEntity;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.module.bussinesscard.model.BussinesscardRecordEntity;
import com.mortals.xhx.module.bussinesscard.service.BussinesscardRecordService;
import com.mortals.xhx.module.company.model.CompanyQuery;
import com.mortals.xhx.module.company.service.CompanyService;
import com.mortals.xhx.module.position.model.PositionQuery;
import com.mortals.xhx.module.position.service.PositionService;
import com.mortals.xhx.module.staff.model.StaffQuery;
import com.mortals.xhx.module.staff.service.StaffService;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.bussinesscard.model.BussinesscardEntity;
import com.mortals.xhx.module.bussinesscard.service.BussinesscardService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSONObject;

import java.util.Arrays;

import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import static com.mortals.framework.ap.SysConstains.*;

/**
 * 名片基本信息
 *
 * @author zxfei
 * @date 2023-10-10
 */
@RestController
@RequestMapping("bussinesscard")
public class BussinesscardController extends BaseCRUDJsonBodyMappingController<BussinesscardService, BussinesscardEntity, Long> {

    @Autowired
    private ParamService paramService;
    @Autowired
    private StaffService staffService;

    @Autowired
    private CompanyService companyService;
    @Autowired
    private PositionService positionService;
    @Autowired
    private BussinesscardRecordService bussinesscardRecordService;
    @Autowired
    private UserService userService;

    public BussinesscardController() {
        super.setModuleDesc("名片基本信息");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "gender", paramService.getParamBySecondOrganize("Bussinesscard", "gender"));
        this.addDict(model, "staffId", staffService.find(new StaffQuery()).stream().collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getName(), (o, n) -> n)));

        this.addDict(model, "companyId", companyService.find(new CompanyQuery()).stream().collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getCompanyName(), (o, n) -> n)));
        this.addDict(model, "positionId", positionService.find(new PositionQuery()).stream().collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getPositionName(), (o, n) -> n)));



        super.init(model, context);
    }

    @Override
    protected int viewAfter(Long id, Map<String, Object> model, BussinesscardEntity entity, Context context) throws AppException {
        saveRecord(entity,context);
        return 1;
    }

    @Override
    protected int infoAfter(Long id, Map<String, Object> model, BussinesscardEntity entity, Context context) throws AppException {
        saveRecord(entity,context);
        return 1;
    }

    /**
     * 保存名片被查看记录
     * @param entity
     * @param context
     */
    private void saveRecord(BussinesscardEntity entity, Context context){
        if(entity!=null){
            if(context!=null&&context.getUser()!=null){

                UserEntity userEntity = userService.get(context.getUser().getId());
                if(userEntity!=null){
                    //非本人浏览时才增加浏览次数
                    if(!(userEntity.getStaffId()!=null && userEntity.getStaffId().longValue()==entity.getStaffId().longValue())){
                        staffService.saveView(entity.getStaffId());
                        Map condition = new HashMap();
                        condition.put("id",entity.getId());
                        Map data = new HashMap();
                        data.put("sumViewsIncrement",1);
                        data.put("viewsByDayIncrement",1);
                        service.getDao().update(data,condition);
                        bussinesscardRecordService.saveRecord(entity, context);
                    }
                }
            }
        }
    }
}